% homotopy function - using matrix variables in memory

Hv=repmat(NaN,[L L]); % residual
Hf=repmat(NaN,[L L]); % residual
FOC=repmat(NaN,[L L]);
W0r=repmat(0,[L L 2]);
W1r=repmat(0,[L L 2]);

% v=v/100;
% profit=profit/100;
% invt=invt/100;
disp(' ')
for i=1:L
for j=1:L
    % conditional expectations of future value
    % conditional on our investment success
    W1(i,j)=0; W0(i,j)=0; W2=1;
    
    pr2=a*invt(j,i)/(1+a*invt(j,i));
    for di=0:1 % forgetting outcome
    for ii=0:1 % competitor investment outcome
%         pr3 = d^di * (1-d)^(1-di) * pr2^ii * (1-pr2)^(1-ii);
        pr3=1;
		if (di==1) 
			pr3 = pr3*d;
        else
			pr3 = pr3*(1.0-d);
        end
		if (ii==1) 
			pr3 = pr3*pr2;
        else
			pr3 = pr3*(1.0-pr2);
        end
        
        if i==18 & j==5
            disp([pr3 v( max(1,min(L,i+1-di)), max(1,min(L,j+ii-di))) v( max(1,min(L,i-di)), max(1,min(L,j+ii-di))) ])
        end
        W1(i,j)=W1(i,j) + pr3 * v( max(1,min(L,i+1-di)), max(1,min(L,j+ii-di)));
        W0(i,j)=W0(i,j) + pr3 * v( max(1,min(L,i-di)), max(1,min(L,j+ii-di)));
        
        W1r(i,j,di+1) = W1r(i,j,di+1)+pr3 * v( max(1,min(L,i+1-di)), max(1,min(L,j+ii-di)));
        W0r(i,j,di+1) = W0r(i,j,di+1)+pr3 * v( max(1,min(L,i-di)), max(1,min(L,j+ii-di)));
        W2=W2-pr3; 
    end
    end
    if abs(W2)>1e-10
error('conditional expectation probability does not add up to 1')
    end
    
    FOC(i,j)=a*B*(W1(i,j)-W0(i,j)) - (1+a*invt(i,j))^2;
    if invt(i,j)>0
        zeta(i,j) = -sqrt(invt(i,j));
    else
        zeta(i,j) = sqrt(abs( FOC(i,j) ));
    end
    
    % bellman eq
    pr1 = a*invt(i,j)/(1+a*invt(i,j));
    Hv(i,j) = -v(i,j) + profit(i,j,1) -invt(i,j) + B * ( pr1*W1(i,j) + (1-pr1)*W0(i,j) );
    Hf(i,j) = FOC(i,j) + max(0,zeta(i,j))^2;
    
end
end

disp(max(max(abs(Hv))))
disp(max(max(abs(Hf))))
