% QLD model: transition matrix
% written by Ron, modified by SK

% check if we have the matrix already
if exist('transfn2D','var') & ~isempty(transfn2D)
    return
end
disp('computing transition matrix')
% compute 4D transition function 
% SK:& transform into 2D
counter=0;
for i=1:L
    for j=1:L

        transfn(i,j,:,:)= (1-d)*squeeze(p1eta0(i,j,:))*squeeze(p2eta0(i,j,:))' + d*squeeze(p1eta1(i,j,:))*squeeze(p2eta1(i,j,:))';
%         transfn(i,j,:,:)=squeeze(pw1(i,j,:))*squeeze(pw2(i,j,:))';

        % check that all matrices transfn(i,j,:,:) sum to 1
        transfnsum(i,j) = sum(sum(transfn(i,j,:,:)));
        
        % convert 4D transition function into a 2D matrix
        counter=counter+1;
        counter2=0;
        for ii=1:L
            for jj=1:L
                counter2=counter2+1;
                transfn2D(counter,counter2)=transfn(i,j,ii,jj);
            end
        end
        
    end
end

% % check that all matrices transfn(i,j,:,:) sum to 1
% SK - moved to loop above
% for i=1:L
%     for j=1:L
%         transfnsum(i,j) = sum(sum(transfn(i,j,:,:)));
%     end
% end

if max(abs(max(max(transfnsum))-1),abs(min(min(transfnsum))-1))>1e-12
    fprintf('There is an error in the transition function.')
end

% % convert 4D transition function into a 2D matrix
% SK: integrated into loop above
% counter=0;
% for i=1:L
%     for j=1:L
%         counter=counter+1;
%         counter2=0;
%         for ii=1:L
%             for jj=1:L
%                 counter2=counter2+1;
%                 transfn2D(counter,counter2)=transfn(i,j,ii,jj);
%             end
%         end
%     end
% end

transfn2Dsum=sum(transfn2D')';
if max(abs(max(max(transfn2Dsum))-1),abs(min(min(transfnsum))-1))>1e-12
    fprintf('There is an error in the 2D version of the transition function, transfn2D.')
end


