% This script computes the expected Herfindahl, using the limiting
% distribution if it was computed and, otherwise, using the last transient
% distribution that was computed.

for i=1:L
    for j=1:L       
        herf(i,j) = ( (exp(nu(i)-p(i,j,1)))^2 + (exp(nu(j)-p(i,j,2)))^2 )/( exp(nu(i)-p(i,j,1)) ...
              + exp(nu(j)-p(i,j,2)) )^2;
    end
end
  
if limdisexists
    expherf = sum(sum(limdismatrix.*herf));
else
    expherf = sum(sum(lasttransdis.*herf));
end