

% compute transition function
for i=1:L
    for j=1:L

        transfn(i,j,:,:)= (1-d)*squeeze(p1eta0(i,j,:))*squeeze(p2eta0(i,j,:))' + d*squeeze(p1eta1(i,j,:))*squeeze(p2eta1(i,j,:))';
%         transfn(i,j,:,:)=squeeze(pw1(i,j,:))*squeeze(pw2(i,j,:))';
    end
end

% check that all matrices transfn(i,j,:,:) sum to 1
for i=1:L
    for j=1:L
        transfnsum(i,j) = sum(sum(transfn(i,j,:,:)));
    end
end

if max(abs(max(max(transfnsum))-1),abs(min(min(transfnsum))-1))>1e-12
    fprintf('There is an error in the transition function.')
end

% convert 4D transition function into a 2D matrix
counter=0;
for i=1:L
    for j=1:L
        counter=counter+1;
        counter2=0;
        for ii=1:L
            for jj=1:L
                counter2=counter2+1;
                transfn2D(counter,counter2)=transfn(i,j,ii,jj);
            end
        end
    end
end

transfn2Dsum=sum(transfn2D')';
if max(abs(max(max(transfn2Dsum))-1),abs(min(min(transfnsum))-1))>1e-12
    fprintf('There is an error in the 2D version of the transition function, transfn2D.')
end



nos = L^2; % number of states
aaa = transfn2D-eye(nos);
limdisexists=0;

rankmatrix = rank(([aaa(:,1:nos-1) ones(nos,1)])); % rank of matrix to be inverted
if rankmatrix==nos
% if rank(([aaa(:,1:nos-1) ones(nos,1)]))==nos
    limdisexists=1;
end

% limdisexists=1; % uncomment this if you want to compute limdis even when matrix to be inverted is not of full rank

if limdisexists
    rhs = zeros(1,nos);
    rhs(1,nos)=1;
%     limdis=rhs*inv([aaa(:,1:nos-1) ones(nos,1)]);
    limdis=rhs/([aaa(:,1:nos-1) ones(nos,1)]);

% % In the 3 lines below, the limiting distn is computed exactly as in
% % markEE_Lim file I got from Steve (from LBD&OF code); i.e., puts column of
% % ones at left of matrix.  So, this produces same erroneous result as
% % markEE_Lim.
% %%% and I got it from Uli - steve
% %%% this really should have a ccc check
%     rhs = zeros(1,nos);
%     rhs(1,1)=1;
%     limdis=rhs/([ones(nos,1) aaa(:,2:nos) ]);

    limdismatrix=zeros(L,L);

    nnn=0;
    for i=1:L
        for j=1:L
            nnn=nnn+1;
            limdismatrix(i,j)=limdis(nnn);
        end
    end
end