tic

% v=profit(:,:,1)./(1-B); % set the initial value function
% invt=ones(L,L); % set the initial policy function

dis=1;
n=0;
while dis>epsilon & n<maxiter

    n = n+1;

    sp1 = a*invt./(1+a*invt); % firm 1's 'success probability' for each state, as a function of investment 
    sp2 = a*invt'./(1+a*invt'); % firm 2's 'success probability' for each state, as a function of investment 
    
%==============================================================================================================================    
    % compute prob(w1'|w,eta=0)
    for i=1:L-1
        for j=1:L
            p1eta0(i,j,i)   = 1 - sp1(i,j);
            p1eta0(i,j,i+1) = sp1(i,j);
        end
    end
    
    i=L;
    for j=1:L
        p1eta0(i,j,i) = 1;
    end
    
    % compute prob(w1'|w,eta=1)
    for i=2:L
        for j=1:L
            p1eta1(i,j,i-1) = 1 - sp1(i,j);
            p1eta1(i,j,i) = sp1(i,j);
        end
    end
    
    i=1;
    for j=1:L
        p1eta1(i,j,i) = 1;
    end
    
    
    % compute prob(w2'|w,eta=0)
    for i=1:L
        for j=1:L-1
            p2eta0(i,j,j)   = 1 - sp2(i,j);
            p2eta0(i,j,j+1) = sp2(i,j);
        end
    end
    
    j=L;
    for i=1:L
        p2eta0(i,j,j) = 1;
    end
    
    % compute prob(w2'|w,eta=1)
    for i=1:L
        for j=2:L
            p2eta1(i,j,j-1) = 1 - sp2(i,j);
            p2eta1(i,j,j) = sp2(i,j);
        end
    end
    
    j=1;
    for i=1:L
        p2eta1(i,j,j) = 1;
    end    
%==============================================================================================================================    


%==============================================================================================================================    
    % compute W1eta0 and W1eta1
    for i=1:L
        for j=1:L
            W1eta0(i,j) = v(i,:)*squeeze(p2eta0(i,j,:));
            W1eta1(i,j) = v(i,:)*squeeze(p2eta1(i,j,:));
        end
    end
%==============================================================================================================================    


%==============================================================================================================================    
    sc=100; % scaling of value function
    % compute invt1
    for i=2:L-1
        for j=1:L
                % steve's fix - use distribution of j' for (i,j) in all expectations
            We0 = v(i,:)*squeeze(p2eta0(i,j,:)); % was W1eta0(i,j)
            We1 = v(i,:)*squeeze(p2eta1(i,j,:)); % was W1eta1(i,j)
            We0_ip = v(i+1,:)*squeeze(p2eta0(i,j,:)); % was W1eta0(i+1,j)
            We1_im = v(i-1,:)*squeeze(p2eta1(i,j,:));% was W1eta1(i-1,j), im = i minus one
                        
            sqrtterm = B*a*( (1-d)*(We0_ip/sc - W1eta0(i,j)/sc) ... 
                            + d*(W1eta1(i,j)/sc - We1_im/sc) )*sc;
            
            if (sqrtterm<0) | (a<=0)
                invt1(i,j)=0; % if the solution to the foc is not well-defined, the optimal investment is zero.
            else
                invt1(i,j) = max(0, (-1 + sqrt(sqrtterm))/a);
            end    
        end
    end
    
    i=1;
        for j=1:L
                % steve's fix - use distribution of j' for (i,j) in all expectations
            We0 = v(i,:)*squeeze(p2eta0(i,j,:)); % was W1eta0(i,j)
            We0_ip = v(i+1,:)*squeeze(p2eta0(i,j,:)); % was W1eta0(i+1,j)
            
            sqrtterm = B*a*( (1-d)*(We0_ip/sc - We0/sc)*sc );
        
            if (sqrtterm<0) | (a<=0)
                invt1(i,j)=0; % if the solution to the foc is not well-defined, the optimal investment is zero.
            else            
                invt1(i,j) = max(0, (-1 + sqrt(sqrtterm))/a);
            end 
        end
    
    i=L;        
        for j=1:L
                % steve's fix - use distribution of j' for (i,j) in all expectations
            We1 = v(i,:)*squeeze(p2eta1(i,j,:)); % was W1eta1(i,j)
            We1_im = v(i-1,:)*squeeze(p2eta1(i,j,:));% was W1eta1(i-1,j), im = i minus one

            sqrtterm = B*a*( d*(W1eta1(i,j)/sc - We1_im/sc)*sc );
            
            if (sqrtterm<0) | (a<=0)
                invt1(i,j)=0; % if the solution to the foc is not well-defined, the optimal investment is zero.
            else            
                invt1(i,j) = max(0, (-1 + sqrt(sqrtterm))/a);
            end    
        end        
%==============================================================================================================================    

    disinvt(n) = max(max(abs((invt1-invt)./(1+abs(invt1)))));
    invt=invt + 1.0*(invt1-invt); % dampened update of policy (investment)

%==============================================================================================================================    
    % compute continuation value, ev
    for i=1:L
        for j=1:L
                % cancelled by steve - W1eta0(:,j) has wrong expectation for rows different from i
%             ev(i,j) = (1-d)*W1eta0(:,j)'*squeeze(p1eta0(i,j,:)) + d*W1eta1(:,j)'*squeeze(p1eta1(i,j,:));
            % steve's fix - code directly from homotopy function
            pr2=a*invt(j,i)/(1+a*invt(j,i));
            W0=0; W1=0; % W2=1;
            for di=0:1 % forgetting outcome
            for ii=0:1 % competitor investment outcome
                pr3 = d^di * (1-d)^(1-di) * pr2^ii * (1-pr2)^(1-ii);
                W1 = W1 + pr3 * v( max(1,min(L,i+1-di)), max(1,min(L,j+ii-di)));
                W0 = W0 + pr3 * v( max(1,min(L,i-di)), max(1,min(L,j+ii-di)));
                
%                 W2=W2-pr3; 
            end
            end
%             if abs(W2)>1e-10
% 		error('conditional expectation probability does not add up to 1')
%             end
            
            pr1 = a*invt(i,j)/(1+a*invt(i,j));
            ev(i,j) = pr1*W1 + (1-pr1)*W0;

        end
    end
%==============================================================================================================================    
    
    v1 = profit(:,:,1) - invt1 + B*ev; % update value function

    disv(n) = max(max(abs((v1-v)./(1+abs(v1)))));
    dis = max(disv(n),disinvt(n));

    v=v + 1.0*(v1-v); % dampened update of value
    
    if mod(n,round(maxiter/10))==0
        disp(sprintf('iter.%3d: d(invt)=%10.2e, d(V)=%10.2e',n, disinvt(n), disv(n) ))
    end
end

numberitervfi=n;
t = toc;
