! After generated by ADIFOR, this file was edited by user 
! to comment out calls to eh* routines (exception handlers)
! This was done b/c function is known to be smooth and needs no exception handling
! and b/c we do not want to add ADIFOR libraries to compilation
! All user edits are commented with '!' rather than 'C'
!
C                           DISCLAIMER
C
C   This file was generated on  by the version of
C   ADIFOR compiled on June, 1998.
C
C   ADIFOR was prepared as an account of work sponsored by an
C   agency of the United States Government, Rice University, and
C   the University of Chicago.  NEITHER THE AUTHOR(S), THE UNITED
C   STATES GOVERNMENT NOR ANY AGENCY THEREOF, NOR RICE UNIVERSITY,
C   NOR THE UNIVERSITY OF CHICAGO, INCLUDING ANY OF THEIR EMPLOYEES
C   OR OFFICERS, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY, COMPLETE-
C   NESS, OR USEFULNESS OF ANY INFORMATION OR PROCESS DISCLOSED, OR
C   REPRESENTS THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
      subroutine g_rho1(n, x, g_x, h, g_h)
C the version of rho.f used as input to ADIFOR
C differences from regular:
C a. different list of agruments. can't have LAMBDA as separate variable
C b. different declaration of inputs - strict Fotran 77 
C c. homotopy parameter is X(N+1) is used instead of LAMBDA
C
C     EVALUATE HOMOTOPY FUNCTION AT X, LAMBDA:=X(N+1) 
C     AND RETURN THE RESULT IN THE VECTOR H.
C
C     ECONOMIC MODEL: Quality ladder duopoly, no EE, GZ+Karl FOC
C
	USE mProfit ! profit function
C     declaration of inputs/outputs 
        integer n
        real*8 x(n + 1)
        real*8 h(n)
C
C     COMMON model parameters
        integer l
        real*8 beta
        real*8 a_beg, a_end
        real*8 d_beg, d_end
        common /modelparams/ beta, a_beg, a_end, d_beg, d_end, l
C offsets in X and H vectors - must be changed for new model
C not necessary, but make indexing and re-ordering columns/rows easier
        integer offv, offz
        integer offbell, offfoc
        common /offsets/ offv, offz, offbell, offfoc
C
C     computed model parameters
        real*8 alpha, delta
C     service variables
        integer i, j, ii, di, ndx1
        real*8 w1, w0, prx, pr1, pr2, pr3
        real*8 invt1, invt2
C     
C
        integer i1
        double precision d4_p, d6_v, d4_b, d9_v, d2_v, d3_v, d10_v, d2_b
     *, d14_v, d1_w
        double precision d1_p, d2_p, d3_p, d13_v, d5_v, g_alpha, g_x(n +
     * 1), g_delta, g_d1_w, g_invt1
        double precision g_invt2, g_w1, g_w0, g_pr2, g_pr3, g_pr1, g_h(n
     *)
        integer g_ehfid
        save g_alpha, g_delta, g_d1_w, g_invt1, g_invt2, g_w1, g_w0, g_p
     *r2, g_pr3, g_pr1
        data g_ehfid /0/
C
!        call ehsfid(g_ehfid, 'rho1','g_QLD_rho1.f')
C
        g_alpha = (a_end - a_beg) * g_x(n + 1)
        alpha = a_beg + x(n + 1) * (a_end - a_beg)
C--------
        g_delta = (d_end - d_beg) * g_x(n + 1)
        delta = d_beg + x(n + 1) * (d_end - d_beg)
C--------
C
        do 99996 i = 1, l
          do 99997 j = 1, l
C      recover own and rival's investment
            ndx1 = ndx(i, j, l)
            g_d1_w = -g_x(offz + ndx1)
            d1_w = -x(offz + ndx1)
            d2_v = max (0.0d0, d1_w)

            if (0.0d0 .gt.  d1_w) then
               d2_p = 1.0d0
               d3_p = 0.0d0
            else if (0.0d0 .lt.  d1_w) then
               d2_p = 0.0d0
               d3_p = 1.0d0
            else
! commented out by user
!               call ehbfDO (7,0.0d0, d1_w, d2_v, d2_p, d3_p,
!     +g_ehfid,
!     +92)
! next 2 lines were added by user in case this case is reached
			PRINT *, "Exception #1 occured" ! added by user
			d2_p = 0.5D0 ! added by user
               d3_p = 1.0d0 -  d2_p
            endif

            if ( d2_v .ne. 0.0d0 ) then
               d3_v = d2_v ** ( 2.0d0 - 2.0d0)
               d3_v =  d3_v * d2_v
               d1_p =  2.0d0 *  d3_v
               d3_v =  d3_v * d2_v
            else
C              (d2_v = 0)
               d3_v = d2_v **  2.0d0

               if (  2.0d0 .lt. 1.0d0 ) then
! commented out by user - this is never reached
!                  call ehbfDO (10,d2_v, 2.0d0, d3_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +108)
               else if (  2.0d0 .lt. 2.0d0 ) then
                  d1_p = 0.0d0
! commented out by user - this is never reached
!                  call ehbfDO (10,d2_v, 2.0d0, d3_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +113)
               else
                  d1_p = 0.0d0
               endif
            endif
            g_invt1 = d1_p * d3_p * g_d1_w
            invt1 = d3_v
C--------
            i1 = ndx(j, i, l)
            g_d1_w = -g_x(offz + i1)
            d1_w = -x(offz + i1)
            d2_v = max (0.0d0, d1_w)

            if (0.0d0 .gt.  d1_w) then
               d2_p = 1.0d0
               d3_p = 0.0d0
            else if (0.0d0 .lt.  d1_w) then
               d2_p = 0.0d0
               d3_p = 1.0d0
            else
! commented out by user 
!               call ehbfDO (7,0.0d0, d1_w, d2_v, d2_p, d3_p,
!     +g_ehfid,
!     +135)
! next 2 lines were added by user in case this case is reached
			PRINT *, "Exception #2 occured" ! added by user
			d2_p = 0.5D0 ! added by user
               d3_p = 1.0d0 -  d2_p
            endif

            if ( d2_v .ne. 0.0d0 ) then
               d3_v = d2_v ** ( 2.0d0 - 2.0d0)
               d3_v =  d3_v * d2_v
               d1_p =  2.0d0 *  d3_v
               d3_v =  d3_v * d2_v
            else
C              (d2_v = 0)
               d3_v = d2_v **  2.0d0

               if (  2.0d0 .lt. 1.0d0 ) then
! commented out by user - this is never reached
!                  call ehbfDO (10,d2_v, 2.0d0, d3_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +151)
               else if (  2.0d0 .lt. 2.0d0 ) then
                  d1_p = 0.0d0
! commented out by user - this is never reached
!                  call ehbfDO (10,d2_v, 2.0d0, d3_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +156)
               else
                  d1_p = 0.0d0
               endif
            endif
            g_invt2 = d1_p * d3_p * g_d1_w
            invt2 = d3_v
C--------
C
C     conditional expectations of future value
C     conditional on our investment success
            g_w1 = 0.0d0
            w1 = 0.0d0
C--------
            g_w0 = 0.0d0
            w0 = 0.0d0
C--------
C      prX=0.0D0 ! probability check, for debugging
C
            d5_v = 1.0d0 + alpha * invt2
            d6_v = alpha * invt2 / d5_v
            d2_b = 1.0d0 / d5_v
            d4_b = (-d6_v) / d5_v
            g_pr2 = (d4_b * alpha + d2_b * alpha) * g_invt2 + (d4_b * in
     *vt2 + d2_b * invt2) * g_alpha
            pr2 = d6_v
C--------
            do 99998 di = 0, 1
              do 99999 ii = 0, 1
                g_pr3 = 0.0d0
                pr3 = 1.0d0
C--------
C
C       Original matlab code: pr3 = d^di * (1-d)^(1-di) * pr2^ii * (1-pr2)^(1-ii
C);
                if (di .eq. 1) then
                  g_pr3 = pr3 * g_delta + delta * g_pr3
                  pr3 = pr3 * delta
C--------
                else
                  d3_v = 1.0d0 - delta
                  g_pr3 = (-pr3) * g_delta + d3_v * g_pr3
                  pr3 = pr3 * d3_v
C--------
                endif
C
                if (ii .eq. 1) then
                  g_pr3 = pr3 * g_pr2 + pr2 * g_pr3
                  pr3 = pr3 * pr2
C--------
                else
                  d3_v = 1.0d0 - pr2
                  g_pr3 = (-pr3) * g_pr2 + d3_v * g_pr3
                  pr3 = pr3 * d3_v
C--------
                endif
C
                i1 = ndx(max(1, min(l, i + 1 - di)), max(1, min(l, j + i
     *i - di)), l)
                g_w1 = pr3 * g_x(offv + i1) + x(offv + i1) * g_pr3 + g_w
     *1
                w1 = w1 + pr3 * x(offv + i1)
C--------
                i1 = ndx(max(1, min(l, i - di)), max(1, min(l, j + ii - 
     *di)), l)
                g_w0 = pr3 * g_x(offv + i1) + x(offv + i1) * g_pr3 + g_w
     *0
                w0 = w0 + pr3 * x(offv + i1)
C--------
C       Debug feature - print probabilities and values
C       IF ((i.eq.18).and.(j.eq.5)) then
C        write(*,'(I2,I2,F17.14,F20.14,F20.14)'), di, ii, pr3, 
C     & X(offV+ndx(max(1,min(L,i+1-di)),max(1,min(L,j+ii-di)),L ))
C     & ,X(offV+ndx(max(1,min(L,i-di)), max(1,min(L,j+ii-di)), L ))
C       endif
C
C             prX=prX+pr3; 
50              continue
99999         continue
99998       continue
C
C     debug feature - check that probabilities add up to 1
C         if (abs(prX-1.0D0)>1e-7) then
C       print*, 'CE prob minus 1.0 = ', prX
C      endif
C
C      Bellman equation
            d5_v = 1.0d0 + alpha * invt1
            d6_v = alpha * invt1 / d5_v
            d2_b = 1.0d0 / d5_v
            d4_b = (-d6_v) / d5_v
            g_pr1 = (d4_b * alpha + d2_b * alpha) * g_invt1 + (d4_b * in
     *vt1 + d2_b * invt1) * g_alpha
            pr1 = d6_v
C--------
            d9_v = 1.0d0 - pr1
            g_h(offbell + ndx1) = beta * d9_v * g_w0 + beta * pr1 * g_w1
     * + (-(beta * w0) + beta * w1) * g_pr1 + (-g_invt1) + (-g_x(offv + 
     *ndx1))
            h(offbell + ndx1) = -x(offv + ndx1) + profit(ndx1) - invt1 +
     * beta * (pr1 * w1 + d9_v * w0)
C--------
C
C      FOC equation
            d2_v = alpha * beta
            d5_v = w1 - w0

            if ( (1.0d0 + alpha * invt1) .ne. 0.0d0 ) then
               d10_v = (1.0d0 + alpha * invt1) ** ( 2.0d0 - 2.0d0)
               d10_v =  d10_v * (1.0d0 + alpha * invt1)
               d4_p =  2.0d0 *  d10_v
               d10_v =  d10_v * (1.0d0 + alpha * invt1)
            else
C              ((1.0d0 + alpha * invt1) = 0)
               d10_v = (1.0d0 + alpha * invt1) **  2.0d0

               if (  2.0d0 .lt. 1.0d0 ) then
! commented out by user - this is never reached
!                  call ehbfDO (10,1.0d0 + alpha * invt1, 2.0d0, d10_v, d
!     +4_p, 0.0d0,
!     +g_ehfid,
!     +276)
               else if (  2.0d0 .lt. 2.0d0 ) then
                  d4_p = 0.0d0
! commented out by user - this is never reached
!                  call ehbfDO (10,1.0d0 + alpha * invt1, 2.0d0, d10_v, d
!     +4_p, 0.0d0,
!     +g_ehfid,
!     +282)
               else
                  d4_p = 0.0d0
               endif
            endif
            d13_v = max (0.0d0,( x(offz + ndx1)))

            if (0.0d0 .gt. ( x(offz + ndx1))) then
               d2_p = 1.0d0
               d3_p = 0.0d0
            else if (0.0d0 .lt. ( x(offz + ndx1))) then
               d2_p = 0.0d0
               d3_p = 1.0d0
            else
! commented out by user 
!              call ehbfDO (7,0.0d0, x(offz + ndx1), d13_v, d2_p, d3_p,
!     +g_ehfid,
!     +298)
! next 2 lines were added by user in case this case is reached
			PRINT *, "Exception #1 occured" ! added by user
			d2_p = 0.5D0 ! added by user
               d3_p = 1.0d0 -  d2_p
            endif

            if ( d13_v .ne. 0.0d0 ) then
               d14_v = d13_v ** ( 2.0d0 - 2.0d0)
               d14_v =  d14_v * d13_v
               d1_p =  2.0d0 *  d14_v
               d14_v =  d14_v * d13_v
            else
C              (d13_v = 0)
               d14_v = d13_v **  2.0d0

               if (  2.0d0 .lt. 1.0d0 ) then
! commented out by user - this is never reached
!                  call ehbfDO (10,d13_v, 2.0d0, d14_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +314)
               else if (  2.0d0 .lt. 2.0d0 ) then
                  d1_p = 0.0d0
! commented out by user - this is never reached
!                  call ehbfDO (10,d13_v, 2.0d0, d14_v, d1_p, 0.0d0,
!     +g_ehfid,
!     +319)
               else
                  d1_p = 0.0d0
               endif
            endif
            g_h(offfoc + ndx1) = d1_p * d3_p * g_x(offz + ndx1) + (-d4_p
     *) * alpha * g_invt1 + (-d2_v) * g_w0 + d2_v * g_w1 + ((-d4_p) * in
     *vt1 + d5_v * beta) * g_alpha
            h(offfoc + ndx1) = d2_v * d5_v - d10_v + d14_v
C--------
C
C     Debug feature - can put breakpoint on continue, so it stops at specific st
Cate
C     then use watch fields to evaluate expressions in your code and compare to 
Cmatlab version of function
C      IF ((i.eq.18).and.(j.eq.5)) then
C       continue ! this does nothing, but you can put breakpoint on it
C      ENDIF
C
100         continue
99997     continue
101       continue
99996   continue
C
      end
C
!	function ndx(...) is not affected by differentiation, 
!	and keeping it in causes "function already defined error"
!      integer function ndx(i, j, l)
C     function ndx(i,j,L)
C     returns index of (i,j) in vectorized L*L matrix
C     probably should enforce (i,j) in [1:L], but it's ok in this short piece of
C code
!        integer i, j, l
!        ndx = (j - 1) * l + i
!      end
